﻿package {
	/*
	copyright Qwaz(qwazpia@gmail.com)

	MIT License
	Text Plugin v1.1

	http://blog.naver.com/yechan54/10136375579
	*/

	import com.qwazlab.NamemaN.Plugin;
	import flash.events.Event;
	
	public class Text extends Plugin {
		public var textPattern:RegExp;
		
		public function Text():void {
			_pluginName = 'Text';
			_version = 1.1;
			
			before.addEventListener(Event.CHANGE, propertyChanged);
			after.addEventListener(Event.CHANGE, propertyChanged);
			noticeCase.addEventListener(Event.CHANGE, propertyChanged);
			convertAll.addEventListener(Event.CHANGE, propertyChanged);
		}
		
		override public function update():void {
			var i:int;
			var len:int = before.text.length;
			var char:String;
			var changed:String='';
			for(i=0; i<len; i++){
				char = before.text.charAt(i);
				changed += '['+((char==']' || char=='-' || char=='\\')?'\\':'')+char+']';
			}
			textPattern = new RegExp(changed, (convertAll.selected?'g':'')+(noticeCase.selected?'':'i'));
		}
		
		override public function convert(input:String):String {
			return input.replace(textPattern, after.text);
		}
		
		private function propertyChanged(e:Event):void {
			if(this.updateExternal != null) this.updateExternal();
		}
	}
}
